#################################################################################
# hidden_user.pl (Hidden User Perl Script)                                      #
#################################################################################
# Written for YaBB 2.x                                                          #
# Author: Brian Longo (aka, Mongo)                                              #
# email: webamster@eyeontoccoa.com                                              #
# http://www.eyeontoccoa.com/bb/                                                #
# Version: 1.7                                                                  #
# Date: January 19, 2006                                                        #
# Version History:                                                              #
# 1.1 - original release                                                        #
# 1.2 - added switch to count Admins and GMods in User Counts                   #
# 1.3 & 1.4 - changed version numbers to match mod.  No changes to this file    #
#             made since version 1.2                                            # 
# 1.5 - added switch to allow only Admins and GMods to see hidden user data     #
# 1.6 - added switch to only allow Admins and GMods to hide and to disallow any #
#       other member class from having the option to hide                       #
#     - added switch to clear users' "hide_me" variable.                        #
# 1.7 - Upped this version number to match mod.  No changes made to this file.  #
#################################################################################

if($action eq 'detailedversion') { return 1; }

LoadLanguage("hidden_user");

if(!-e("$vardir/hidden_user.txt"))  {
	&hidden_user_set_2;
}

require "$vardir/hidden_user.txt";

sub hidden_user_set {
  
	if ($allow_hidden) { $hiddenchecked = ' checked'; }
	if ($allow_hidden_admin_gmod) { $hidden_ag_checked = ' checked'; } 
	if ($count_admin_gmod) { $countchecked = ' checked'; }
	if ($only_admin_gmod_view) { $onlyadmgmodchecked = ' checked'; }
	if ($clear_data) { $clearchecked = ' checked';}
	$yymain .= qq~

<form action="$adminurl?action=hidden_user2" method="post">
 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       <td align="left" class="titlebg">
		 <img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$hidden_txt{'6'}</b>
	   </td>
     </tr>
     <tr align="center" valign="middle">
       <td align="left" class="catbg"><span class="small">$hidden_txt{'7'} <i>$hidden_txt{'8'}</i></span>
	   </td>
     </tr>
     <tr align="center" valign="middle">
       <td align="left" class="windowbg2" style="background-color: black;"><span style="font-weight: bold; font-size: 12px; color: white;">$hidden_txt{'17'}</span></td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">
    <div class="setting_cell">$hidden_txt{'5'}</div>
    <div class="setting_cell2"><input type="checkbox" name="allow_hidden" $hiddenchecked /></div>
	<br />
    <div class="setting_cell">$hidden_txt{'9'}</div>
    <div class="setting_cell2"><input type="checkbox" name="count_admin_gmod" $countchecked /></div>
	   </td>
     </tr>
     <tr align="center" valign="middle">
       <td align="left" class="windowbg2" style="background-color: green;"><span style="font-weight: bold; font-size: 12px; color: white;">$hidden_txt{'19'}</span></td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">	
	<div class="setting_cell">$hidden_txt{'5a'}</div>
    <div class="setting_cell2"><input type="checkbox" name="allow_ag_hidden" $hidden_ag_checked /></div>
	<br />	
    <div class="setting_cell">$hidden_txt{'13'}</div>
    <div class="setting_cell2"><input type="checkbox" name="only_admin_gmod_view" $onlyadmgmodchecked /></div>
	<br />
	   </td>
     </tr>
     <tr align="center" valign="middle">
       <td align="left" class="windowbg2" style="background-color: red;"><span style="font-weight: bold; font-size: 12px; color: white;">$hidden_txt{'18'}</span></td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2" style="background-color: yellow;">
	 <div class="setting_cell">$hidden_txt{'15'}</div>
     <div class="setting_cell2"><input type="checkbox" name="clear_data" $clearchecked /></div>
	   </td>
     </tr>
   </table>
 </div>

<br />

 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       <td align="center" class="catbg">
		 <input type="submit" value="$admin_txt{'10'}" />
	   </td>
     </tr>
   </table>
 </div>
</form>

<br />

 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr align="center" valign="middle">
       <td align="left" class="windowbg2" style="background-color: blue;"><span style="font-weight: bold; font-size: 12px; color: white;">$hidden_txt{'20'}</span></td>
     </tr>
	 <tr valign="middle">
       <td class="windowbg2">
		$hidden_txt{'14'}<br /><br />$hidden_txt{'14a'}
	   </td>
     </tr>
	 <tr valign="middle">
     <td class="windowbg2" style="background-color: yellow;">
		$hidden_txt{'16'} 
	   </td>
     </tr>
   </table>
 </div>

	~;
	
	$yytitle = $admin_txt{'222'};
	$action_area = "hidden_user";
	&check_user_hidden_value;
	&AdminTemplate;
	exit;

}
	
sub hidden_user_set_2 {

    &is_admin_or_gmod;

	$allow_hidden = $FORM{'allow_hidden'} ? 1 : 0;
	$allow_hidden_admin_gmod = $FORM{'allow_ag_hidden'} ? 1 : 0;
	$count_admin_gmod = $FORM{'count_admin_gmod'} ? 1 : 0;
	$only_admin_gmod_view = $FORM{'only_admin_gmod_view'} ? 1 : 0;
	$clear_data = $FORM{'clear_data'} ? 1 : 0;
	
	my $setfile = << "EOF";
###############################################################################
# hidden_user.txt (Hidden User configurations)                                #       
###############################################################################

\$allow_hidden = $allow_hidden;	# set to 1 to allow hidden members
\$allow_hidden_admin_gmod = $allow_hidden_admin_gmod; #set to 1 to only allow Admins and GMods to be hidden - all other users will not allowed to become hidden
\$count_admin_gmod = $count_admin_gmod; # set to 1 to count admins and gmod in totals
\$only_admin_gmod_view = $only_admin_gmod_view; # set to 1 to only allow admins and gmods to see hidden users on board index 

1;
EOF

	fopen(FILE, ">$vardir/hidden_user.txt");
	print FILE $setfile;
	fclose(FILE);
	if ($action eq "hidden_user2") {
		&check_user_hidden_value;
		$yySetLocation = qq~$adminurl?action=hidden_user~;
		&redirectexit;
	}
}

sub check_user_hidden_value {
	if ($clear_data eq 1){
	   fopen(MEM_HID,"$memberdir/memberlist.txt");
	   @mem_hid = <MEM_HID>;
	   fclose(MEM_HID);
	   foreach $mementry (@mem_hid){
	      chomp $mementry;
	      ($uname, $blank) = split(/\t/, $mementry);
		  if($uname) {
		     unless (${$uid.$uname}{'realname'}) { &LoadUser($uname); }
		     &LoadMiniUser($uname);
  		     if(${$uid.$uname}{'position'} eq "Administrator" && ${$uid.$uname}{'hide_me'} eq "on"){
			    ${$uid.$uname}{'hide_me'} = "on";
				&UserAccount($uname, "update");
			 }
			 elsif(${$uid.$uname}{'position'} eq "Global Moderator" && ${$uid.$uname}{'hide_me'} eq "on"){
			    ${$uid.$uname}{'hide_me'} = "on";
				&UserAccount($uname, "update");
			 }
			 else{
		        ${$uid.$uname}{'hide_me'} = "";
			    &UserAccount($uname, "update");
			 }
		  }
	   }
	}
}

1;